/* this version is for MS VC++  */

#include <stdio.h>
#include <stdlib.h>

#include "keyring.h"

extern unsigned short int verbose;

unsigned short int find_offset (char *executable_path) {

    /*
	*
	* NOTE: search algorithm depends on each byte in this
    * pattern being different.
	*
    */

    int pattern[] = { 0xc1, 0xe0, 0x08, 0x99, 0x09, 0x05 };
    FILE *fp;
    int c;
    unsigned int pos = 0;
    unsigned int last = sizeof pattern / sizeof (int) - 1;
    unsigned long offset = 0;

	if (verbose) {
		printf("find_offset subrotine running\n");
		printf("searching for the key location offset for executable\n");
		printf("\t%s\n\n", executable_path);
		}

	if ((fp = fopen(executable_path, "rb")) == NULL) {
        fprintf(stderr, "Cannot open %s\n", executable_path);
        exit(1);
    	}

    while ( (c = getc(fp)) != EOF) {

        if (c == pattern[pos]) {
			if (pos == last) {
				if (verbose) {
					printf("looks like we round a match.  breaking out.\n");
					}
                break;
            }
            else {
                pos++;
            }
        }
        else {
            pos = 0;
        }
    }
    if (c == EOF) {
        printf("Key offset not found.\n");
        exit(1);
    }
    /* next four bytes will be the key offset as a little-endian long */
    for (pos = 0; pos <= 3; pos++) {
		if (verbose) {
			printf("Found bit %i\n", pos);
			}
        if ( (c = getc(fp)) == EOF ) {
            printf("Error while reading offset\n");
            exit(1);
        }
        offset = (offset>>8) | (c << 24);
    }
    printf("\nSessionKeyLocation=%8.8#x\n", offset);
    return 0;
}
